## libsignal-protocol-c 2.3.1+git20171007

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")
project(signal-protocol-c)

if(POLICY CMP0042)
	cmake_policy(SET CMP0042 NEW)
endif()

SET(SIGNAL_PROTOCOL_C_VERSION_MAJOR 2)
SET(SIGNAL_PROTOCOL_C_VERSION_MINOR 3)
SET(SIGNAL_PROTOCOL_C_VERSION_PATCH 1)
SET(SIGNAL_PROTOCOL_C_VERSION ${SIGNAL_PROTOCOL_C_VERSION_MAJOR}.${SIGNAL_PROTOCOL_C_VERSION_MINOR}.${SIGNAL_PROTOCOL_C_VERSION_PATCH})

SET(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
SET(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE STRING "The directory the binaries are installed in")
SET(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "The directory the libraries are installed in")
SET(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "The directory the headers are installed in")
SET(INSTALL_PKGCONFIG_DIR "${LIB_INSTALL_DIR}/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")

INCLUDE(CheckSymbolExists)
INCLUDE(CheckCCompilerFlag)

CHECK_SYMBOL_EXISTS(memset_s "string.h" HAVE_MEMSET_S)

IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
	CHECK_SYMBOL_EXISTS(SecureZeroMemory "Windows.h;WinBase.h" HAVE_SECUREZEROMEMORY)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "Windows")

IF(BUILD_TESTING)
	enable_testing()
ENDIF(BUILD_TESTING)

IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmessage-length=0 -Wall -Wmissing-field-initializers -Wno-missing-braces -Wparentheses")
ENDIF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")

IF(CMAKE_COMPILER_IS_GNUCC)
	CHECK_C_COMPILER_FLAG("-Wsign-conversion" GCC_WARN_SIGN_CONVERSION)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsign-compare")
	IF(GCC_WARN_SIGN_CONVERSION)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsign-conversion")
	ENDIF(GCC_WARN_SIGN_CONVERSION)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

IF(CMAKE_C_COMPILER_ID MATCHES "Clang")
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wswitch -Wunused-variable -Wunused-value -Wshadow -Wint-conversion -Wpointer-sign -Wprotocol -Wshorten-64-to-32")
ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang")

IF(HAVE_MEMSET_S)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_MEMSET_S=1")
ENDIF(HAVE_MEMSET_S)

IF(COVERAGE)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
	SET(LINK_FLAGS "${LINK_FLAGS} -fprofile-arcs -ftest-coverage")

	add_custom_command(OUTPUT run_coverage
			COMMAND ctest
			COMMAND lcov -q --capture --directory src --output-file coverage.info.total
			COMMAND lcov -q --remove coverage.info.total 'vpool.*' 'ut*.h' '*.pb-c.*' 'protobuf-c/*' 'curve25519/*' --output-file coverage.info
			COMMAND genhtml -q coverage.info --output-directory coverage
			COMMENT Collecting and creating coverage information
	)
	add_custom_target( coverage DEPENDS run_coverage )
ENDIF(COVERAGE)

add_subdirectory(src)

IF(BUILD_TESTING)
	add_subdirectory(tests)
ENDIF(BUILD_TESTING)

=== tests/CMakeLists.txt ===
enable_testing()
find_library(M_LIB m)
find_package(Check REQUIRED)
IF(NOT(APPLE AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
  find_package(OpenSSL 1.0 REQUIRED)
ENDIF()
find_package(Threads)
include_directories(${CHECK_INCLUDE_DIRS})

IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
ENDIF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")

IF(CMAKE_COMPILER_IS_GNUCC)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare")
	IF(GCC_WARN_SIGN_CONVERSION)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-conversion")
	ENDIF(GCC_WARN_SIGN_CONVERSION)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

IF(CMAKE_C_COMPILER_ID MATCHES "Clang")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-invalid-source-encoding -Wno-shorten-64-to-32")
ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang")

# On Windows .exe and .dll files must be placed at the same directory
if(WIN32 AND BUILD_SHARED_LIBS)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/src)
  set(TEST_PATH ${CMAKE_BINARY_DIR}/src)
else()
  set(TEST_PATH ${CMAKE_CURRENT_BINARY_DIR})
endif()

set(LIBS ${LIBS}
	${M_LIB}
	${CHECK_LDFLAGS}
	${OPENSSL_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	${CMAKE_DL_LIBS}
	signal-protocol-c
)

set(common_SRCS
	test_common.c
	test_common.h
)

include_directories(. ../src)

IF(APPLE AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(common_SRCS ${common_SRCS}
		test_common_ccrypto.c
	)
ELSE()
	set(common_SRCS ${common_SRCS}
		test_common_openssl.c
	)
	include_directories(${OPENSSL_INCLUDE_DIR})
ENDIF()

add_executable(test_curve25519 test_curve25519.c ${common_SRCS})
target_link_libraries(test_curve25519 ${LIBS})
add_test(test_curve25519 ${TEST_PATH}/test_curve25519)

add_executable(test_hkdf test_hkdf.c ${common_SRCS})
target_link_libraries(test_hkdf ${LIBS})
add_test(test_hkdf ${TEST_PATH}/test_hkdf)

add_executable(test_ratchet test_ratchet.c ${common_SRCS})
target_link_libraries(test_ratchet ${LIBS})
add_test(test_ratchet ${TEST_PATH}/test_ratchet)

add_executable(test_protocol test_protocol.c ${common_SRCS})
target_link_libraries(test_protocol ${LIBS})
add_test(test_protocol ${TEST_PATH}/test_protocol)

add_executable(test_session_record test_session_record.c ${common_SRCS})
target_link_libraries(test_session_record ${LIBS})
add_test(test_session_record ${TEST_PATH}/test_session_record)

add_executable(test_session_cipher test_session_cipher.c ${common_SRCS})
target_link_libraries(test_session_cipher ${LIBS})
add_test(test_session_cipher ${TEST_PATH}/test_session_cipher)

add_executable(test_session_builder test_session_builder.c ${common_SRCS})
target_link_libraries(test_session_builder ${LIBS})
add_test(test_session_builder ${TEST_PATH}/test_session_builder)

add_executable(test_key_helper test_key_helper.c ${common_SRCS})
target_link_libraries(test_key_helper ${LIBS})
add_test(test_key_helper ${TEST_PATH}/test_key_helper)

add_executable(test_simultaneous_initiate test_simultaneous_initiate.c ${common_SRCS})
target_link_libraries(test_simultaneous_initiate ${LIBS})
add_test(test_simultaneous_initiate ${TEST_PATH}/test_simultaneous_initiate)

add_executable(test_sender_key_record test_sender_key_record.c ${common_SRCS})
target_link_libraries(test_sender_key_record ${LIBS})
add_test(test_sender_key_record ${TEST_PATH}/test_sender_key_record)

add_executable(test_group_cipher test_group_cipher.c ${common_SRCS})
target_link_libraries(test_group_cipher ${LIBS})
add_test(test_group_cipher ${TEST_PATH}/test_group_cipher)

add_executable(test_fingerprint test_fingerprint.c ${common_SRCS})
target_link_libraries(test_fingerprint ${LIBS})
add_test(test_fingerprint ${TEST_PATH}/test_fingerprint)

add_executable(test_device_consistency test_device_consistency.c ${common_SRCS})
target_link_libraries(test_device_consistency ${LIBS})
add_test(test_device_consistency ${TEST_PATH}/test_device_consistency)

=== src/protobuf-c/CMakeLists.txt ===
IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-shadow")
ENDIF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")

IF(CMAKE_COMPILER_IS_GNUCC)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare")
	IF(GCC_WARN_SIGN_CONVERSION)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-conversion")
	ENDIF(GCC_WARN_SIGN_CONVERSION)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

IF(CMAKE_C_COMPILER_ID MATCHES "Clang")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-shorten-64-to-32")
ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang")

set(protobuf_SRCS
	protobuf-c.c
)

add_library(protobuf-c OBJECT ${protobuf_SRCS})

# Add -fPIC flag
if(BUILD_SHARED_LIBS)
	set_property(TARGET protobuf-c PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

=== debian/changelog ===
libsignal-protocol-c (2.3.1+git20171007-3) unstable; urgency=medium

  * Minor updates: Bumped standards version, fixed Multi-Arch,
    change maintainership to XMPP team at salsa.debian.org.

 -- W. Martin Borgert <debacle@debian.org>  Sun, 04 Feb 2018 18:47:03 +0000

libsignal-protocol-c (2.3.1+git20171007-2) unstable; urgency=medium

  * Upload to unstable.

 -- W. Martin Borgert <debacle@debian.org>  Mon, 18 Dec 2017 21:37:37 +0000

libsignal-protocol-c (2.3.1+git20171007-1) experimental; urgency=medium

  * Initial release. (Closes: #840366)

 -- W. Martin Borgert <debacle@debian.org>  Thu, 19 Oct 2017 21:32:35 +0000

=== debian/control ===
Source: libsignal-protocol-c
Section: devel
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: W. Martin Borgert <debacle@debian.org>,
 Dominik George <nik@naturalnet.de>
Standards-Version: 4.1.3
Rules-Requires-Root: no
Build-Depends:
 check,
 cmake,
 debhelper (>= 10~),
 dpkg-dev (>= 1.16.1),
 libssl-dev,
 protobuf-c-compiler,
Homepage: https://github.com/WhisperSystems/libsignal-protocol-c
Vcs-Git: https://salsa.debian.org/xmpp-team/libsignal-protocol-c.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/libsignal-protocol-c

Package: libsignal-protocol-c-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libsignal-protocol-c2 (= ${binary:Version}),
 ${misc:Depends},
Description: ratcheting forward secrecy protocol for synchronous and asynchronous messaging
 This is a ratcheting forward secrecy protocol that works in
 synchronous and asynchronous messaging environments.
 .
 This package contains the development files.

Package: libsignal-protocol-c2
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ratcheting forward secrecy protocol for synchronous and asynchronous messaging
 This is a ratcheting forward secrecy protocol that works in
 synchronous and asynchronous messaging environments.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_build:
	( cd protobuf ; $(MAKE) )
	dh_auto_build

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DLIB_INSTALL_DIR=/usr/lib/${DEB_HOST_MULTIARCH}

## libsignal-protocol-c 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 SET(SIGNAL_PROTOCOL_C_VERSION_MAJOR 2)
 SET(SIGNAL_PROTOCOL_C_VERSION_MINOR 3)
-SET(SIGNAL_PROTOCOL_C_VERSION_PATCH 1)
+SET(SIGNAL_PROTOCOL_C_VERSION_PATCH 2)
 SET(SIGNAL_PROTOCOL_C_VERSION ${SIGNAL_PROTOCOL_C_VERSION_MAJOR}.${SIGNAL_PROTOCOL_C_VERSION_MINOR}.${SIGNAL_PROTOCOL_C_VERSION_PATCH})
 
 SET(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")

=== debian/changelog ===
libsignal-protocol-c (2.3.2-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Jonas Meurer <jonas@freesources.org>  Sun, 10 Nov 2019 21:29:31 +0100

libsignal-protocol-c (2.3.2-2) unstable; urgency=medium

  * Re-upload to unstable.

 -- W. Martin Borgert <debacle@debian.org>  Fri, 19 Jul 2019 06:51:49 +0000

libsignal-protocol-c (2.3.2-1) experimental; urgency=medium

  * New upstream version (Closes: #901948).
  * Use full library version for soname.

 -- W. Martin Borgert <debacle@debian.org>  Thu, 30 May 2019 20:48:54 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  check,
  cmake,
- debhelper (>= 10~),
+ debhelper-compat (= 11),
  dpkg-dev (>= 1.16.1),
  libssl-dev,
  protobuf-c-compiler,
@@ -22,7 +22,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libsignal-protocol-c2 (= ${binary:Version}),
+ libsignal-protocol-c2.3.2 (= ${binary:Version}),
  ${misc:Depends},
 Description: ratcheting forward secrecy protocol for synchronous and asynchronous messaging
  This is a ratcheting forward secrecy protocol that works in
@@ -30,7 +30,7 @@
  .
  This package contains the development files.
 
-Package: libsignal-protocol-c2
+Package: libsignal-protocol-c2.3.2
 Architecture: any
 Multi-Arch: same
 Section: libs

## libsignal-protocol-c 2.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 SET(SIGNAL_PROTOCOL_C_VERSION_MAJOR 2)
 SET(SIGNAL_PROTOCOL_C_VERSION_MINOR 3)
-SET(SIGNAL_PROTOCOL_C_VERSION_PATCH 2)
+SET(SIGNAL_PROTOCOL_C_VERSION_PATCH 3)
 SET(SIGNAL_PROTOCOL_C_VERSION ${SIGNAL_PROTOCOL_C_VERSION_MAJOR}.${SIGNAL_PROTOCOL_C_VERSION_MINOR}.${SIGNAL_PROTOCOL_C_VERSION_PATCH})
 
 SET(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
@@ -19,6 +19,7 @@
 
 INCLUDE(CheckSymbolExists)
 INCLUDE(CheckCCompilerFlag)
+INCLUDE(TestBigEndian)
 
 CHECK_SYMBOL_EXISTS(memset_s "string.h" HAVE_MEMSET_S)
 
@@ -50,6 +51,11 @@
 	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_MEMSET_S=1")
 ENDIF(HAVE_MEMSET_S)
 
+TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
+IF(WORDS_BIGENDIAN)
+	ADD_DEFINITIONS(-DWORDS_BIGENDIAN)
+ENDIF(WORDS_BIGENDIAN)
+
 IF(COVERAGE)
 	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
 	SET(LINK_FLAGS "${LINK_FLAGS} -fprofile-arcs -ftest-coverage")

=== src/CMakeLists.txt ===
if(BUILD_SHARED_LIBS)
	find_library(M_LIB m)
endif()

include_directories(
	.
	curve25519/ed25519/nacl_includes
	curve25519/ed25519/additions
	curve25519/ed25519/sha512
	curve25519/ed25519
	curve25519
)

set(protobuf_SRCS
	LocalStorageProtocol.pb-c.c
	WhisperTextProtocol.pb-c.c
	FingerprintProtocol.pb-c.c
)

set(signal_protocol_SRCS
	vpool.c
	vpool.h
	signal_protocol.c
	signal_protocol.h
	signal_protocol_types.h
	signal_protocol_internal.h
	curve.c
	curve.h
	hkdf.c
	hkdf.h
	ratchet.c
	ratchet.h
	protocol.c
	protocol.h
	session_state.c
	session_state.h
	session_record.c
	session_record.h
	session_pre_key.c
	session_pre_key.h
	session_builder.c
	session_builder.h
	session_builder_internal.h
	session_cipher.c
	session_cipher.h
	key_helper.c
	key_helper.h
	sender_key.c
	sender_key.h
	sender_key_state.c
	sender_key_state.h
	sender_key_record.c
	sender_key_record.h
	group_session_builder.c
	group_session_builder.h
	group_cipher.c
	group_cipher.h
	fingerprint.c
	fingerprint.h
	device_consistency.c
	device_consistency.h
)

add_subdirectory(curve25519)
add_subdirectory(protobuf-c)

add_library(signal-protocol-c
	${protobuf_SRCS}
	${signal_protocol_SRCS}
	$<TARGET_OBJECTS:curve25519>
	$<TARGET_OBJECTS:protobuf-c>
)

if(BUILD_SHARED_LIBS)
	target_link_libraries(signal-protocol-c ${M_LIB})
	set_target_properties(signal-protocol-c PROPERTIES
		VERSION ${SIGNAL_PROTOCOL_C_VERSION}
		SOVERSION ${SIGNAL_PROTOCOL_C_VERSION_MAJOR}
	)
endif()

INSTALL(
	FILES
	signal_protocol.h
	signal_protocol_types.h
	curve.h
	hkdf.h
	ratchet.h
	protocol.h
	session_state.h
	session_record.h
	session_pre_key.h
	session_builder.h
	session_cipher.h
	key_helper.h
	sender_key.h
	sender_key_state.h
	sender_key_record.h
	group_session_builder.h
	group_cipher.h
	fingerprint.h
	device_consistency.h
	DESTINATION ${INCLUDE_INSTALL_DIR}/signal
)

INSTALL(TARGETS signal-protocol-c
	LIBRARY DESTINATION ${LIB_INSTALL_DIR}
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
	ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c.pc.in
		${CMAKE_CURRENT_BINARY_DIR}/libsignal-protocol-c.pc @ONLY)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libsignal-protocol-c.pc DESTINATION "${INSTALL_PKGCONFIG_DIR}")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 enable_testing()
 find_library(M_LIB m)
-find_package(Check REQUIRED)
+find_package(Check 0.9.10 REQUIRED)
 IF(NOT(APPLE AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
   find_package(OpenSSL 1.0 REQUIRED)
 ENDIF()

=== src/curve25519/CMakeLists.txt ===
IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-function -Wno-shadow")
ENDIF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")

IF(CMAKE_COMPILER_IS_GNUCC)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare")
    IF(GCC_WARN_SIGN_CONVERSION)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-conversion")
    ENDIF(GCC_WARN_SIGN_CONVERSION)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

IF(CMAKE_C_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-shorten-64-to-32")
ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang")

include_directories(
    ed25519/nacl_includes
    ed25519/additions
    ed25519/additions/generalized
    ed25519/sha512
    ed25519/tests
    ed25519
)

set(curve25519_SRCS
    curve25519-donna.c
)

set(ed25519_SRCS
    ed25519/fe_0.c
    ed25519/fe_1.c
    ed25519/fe_add.c
    ed25519/fe_cmov.c
    ed25519/fe_copy.c
    ed25519/fe_frombytes.c
    ed25519/fe_invert.c
    ed25519/fe_isnegative.c
    ed25519/fe_isnonzero.c
    ed25519/fe_mul.c
    ed25519/fe_neg.c
    ed25519/fe_pow22523.c
    ed25519/fe_sq.c
    ed25519/fe_sq2.c
    ed25519/fe_sub.c
    ed25519/fe_tobytes.c
    ed25519/ge_add.c
    ed25519/ge_double_scalarmult.c
    ed25519/ge_frombytes.c
    ed25519/ge_madd.c
    ed25519/ge_msub.c
    ed25519/ge_p1p1_to_p2.c
    ed25519/ge_p1p1_to_p3.c
    ed25519/ge_p2_0.c
    ed25519/ge_p2_dbl.c
    ed25519/ge_p3_0.c
    ed25519/ge_p3_dbl.c
    ed25519/ge_p3_to_cached.c
    ed25519/ge_p3_to_p2.c
    ed25519/ge_p3_tobytes.c
    ed25519/ge_precomp_0.c
    ed25519/ge_scalarmult_base.c
    ed25519/ge_sub.c
    ed25519/ge_tobytes.c
    ed25519/open.c
    ed25519/sc_muladd.c
    ed25519/sc_reduce.c
    ed25519/sign.c
    ed25519/additions/compare.c
    ed25519/additions/curve_sigs.c
    ed25519/additions/elligator.c
    ed25519/additions/fe_isequal.c
    ed25519/additions/fe_isreduced.c
    ed25519/additions/fe_mont_rhs.c
    ed25519/additions/fe_montx_to_edy.c
    ed25519/additions/fe_sqrt.c
    ed25519/additions/ge_isneutral.c
    ed25519/additions/ge_montx_to_p3.c
    ed25519/additions/ge_neg.c
    ed25519/additions/ge_p3_to_montx.c
    ed25519/additions/ge_scalarmult.c
    ed25519/additions/ge_scalarmult_cofactor.c
    ed25519/additions/keygen.c
    ed25519/additions/open_modified.c
    ed25519/additions/sc_clamp.c
    ed25519/additions/sc_cmov.c
    ed25519/additions/sc_neg.c
    ed25519/additions/sign_modified.c
    ed25519/additions/utility.c
    ed25519/additions/generalized/ge_p3_add.c
    ed25519/additions/generalized/gen_eddsa.c
    ed25519/additions/generalized/gen_labelset.c
    ed25519/additions/generalized/gen_veddsa.c
    ed25519/additions/generalized/gen_x.c
    ed25519/additions/generalized/point_isreduced.c
    ed25519/additions/generalized/sc_isreduced.c
    ed25519/additions/xeddsa.c
    ed25519/additions/zeroize.c
    ed25519/nacl_sha512/blocks.c
    ed25519/nacl_sha512/hash.c
    ed25519/tests/internal_fast_tests.c
)

add_library(curve25519 OBJECT ${curve25519_SRCS} ${ed25519_SRCS})

# Add -fPIC flag
if(BUILD_SHARED_LIBS)
    set_property(TARGET curve25519 PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

=== debian/changelog ===
libsignal-protocol-c (2.3.3-1) unstable; urgency=medium

  * New upstream version.
    No need to bump soname or package name, no ABI changes.

 -- Martin <debacle@debian.org>  Sat, 02 May 2020 17:09:00 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
-Uploaders: W. Martin Borgert <debacle@debian.org>,
+Uploaders: Martin <debacle@debian.org>,
  Dominik George <nik@naturalnet.de>
 Standards-Version: 4.1.3
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+SOFILE=usr/lib/${DEB_HOST_MULTIARCH}/libsignal-protocol-c.so
 
 %:
 	dh $@ --buildsystem=cmake
@@ -11,3 +13,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DLIB_INSTALL_DIR=/usr/lib/${DEB_HOST_MULTIARCH}
+
+override_dh_link:
+	dh_link -plibsignal-protocol-c2.3.2 ${SOFILE}.2.3.3 ${SOFILE}.2.3.2

=== debian/watch ===
version=3
https://github.com/signalapp/libsignal-protocol-c/tags \
.*/signalapp/libsignal-protocol-c/archive/v(\d.+)\.tar\.gz \
debian uupdate
